From 9ef79116c1e3e4a26d388bbf4172bad2ea3a80e0 Mon Sep 17 00:00:00 2001
From: Philip Cali <philip.cali@gmail.com>
Date: Fri, 3 Feb 2012 14:46:47 -0600
Subject: Interface checks on itemtypes

---
 grade/report/quick_edit/classes/lib.php       |   41 ++++++++++++++++++++++++-
 grade/report/quick_edit/screens/grade/lib.php |   32 ++++++++++++++++---
 grade/report/quick_edit/screens/user/lib.php  |   20 ++++++++----
 3 files changed, 81 insertions(+), 12 deletions(-)

diff --git a/grade/report/quick_edit/classes/lib.php b/grade/report/quick_edit/classes/lib.php
index 78636b0..5c7fa34 100644
--- a/grade/report/quick_edit/classes/lib.php
+++ b/grade/report/quick_edit/classes/lib.php
@@ -52,7 +52,46 @@ abstract class quick_edit_screen {
     }
 
     public function format_exclude($item, $grade) {
-        return $this->checkbox_attribute($grade, 'excldue', $grade->is_excluded());
+        return $this->checkbox_attribute($grade, 'exclude', $grade->is_excluded());
+    }
+
+    public function fetch_grade_or_default($item, $user) {
+        $grade = grade_grade::fetch(array(
+            'itemid' => $item->id, 'userid' => $user->id
+        ));
+
+        if (!$grade) {
+            $default = new stdClass;
+
+            $default->userid = $user->id;
+            $default->itemid = $item->id;
+            $default->feedback = '';
+
+            $grade = new grade_grade($default, false);
+        }
+
+        return $grade;
+    }
+
+    public function make_toggle($key) {
+        $attrs = array('href' => '#');
+
+        $all = html_writer::tag('a', get_string('all'), $attrs + array(
+            'class' => 'include_all ' . $key
+        ));
+
+        $none = html_writer::tag('a', get_string('none'), $attrs + array(
+            'class' => 'include_none ' . $key
+        ));
+
+        return html_writer::tag('span', "$all / $none", array(
+            'class' => 'inclusion_links'
+        ));
+    }
+
+    public function make_toggle_links($key) {
+        return get_string($key, 'gradereport_quick_edit') . ' ' .
+            $this->make_toggle($key);
     }
 
     private function checkbox_attribute($grade, $post_name, $is_checked) {
diff --git a/grade/report/quick_edit/screens/grade/lib.php b/grade/report/quick_edit/screens/grade/lib.php
index 51a5507..14eff7e 100644
--- a/grade/report/quick_edit/screens/grade/lib.php
+++ b/grade/report/quick_edit/screens/grade/lib.php
@@ -2,6 +2,8 @@
 
 class quick_edit_grade extends quick_edit_screen {
 
+    private $requires_extra;
+
     public function init() {
         $add = $this->itemid ?
             array('id' => $this->itemid) :
@@ -15,6 +17,8 @@ class quick_edit_grade extends quick_edit_screen {
 
         $this->users = get_role_users($roleids, $this->context, false, '',
             'u.lastname, u.firstname', null, $this->groupid);
+
+        $this->requires_extra = $this->item->itemtype != 'manual';
     }
 
     public function html() {
@@ -32,33 +36,51 @@ class quick_edit_grade extends quick_edit_screen {
     }
 
     public function headers() {
-        return array(
+        $headers = array(
             '',
             get_string('firstname') . ' / ' . get_string('lastname'),
             get_string('range', 'grades'),
             get_string('grade', 'grades'),
             get_string('feedback', 'grades')
         );
+
+        return $this->additional_headers($headers);
     }
 
     public function format_line($user) {
         global $OUTPUT;
 
-        $grade = grade_grade::fetch(array(
-            'itemid' => $this->item->id, 'userid' => $user->id
-        ));
+        $grade = $this->fetch_grade_or_default($this->item, $user);
 
         $fullname = fullname($user);
 
         $user->imagealt = $fullname;
 
-        return array(
+        $line = array(
             $OUTPUT->user_picture($user),
             $this->format_link('user', $user->id, $fullname),
             $this->item_range(),
             $this->format_grade($grade, $this->item->get_decimals()),
             $this->format_feedback($grade)
         );
+
+        return $this->additional_cells($line, $grade);
+    }
+
+    public function additional_cells($line, $grade) {
+        if ($this->requires_extra) {
+            $line[] = $this->format_override($this->item, $grade);
+        }
+
+        return $line;
+    }
+
+    public function additional_headers($headers) {
+        if ($this->requires_extra) {
+            $headers[] = $this->make_toggle_links('override');
+        }
+
+        return $headers;
     }
 
     public function item_range() {
diff --git a/grade/report/quick_edit/screens/user/lib.php b/grade/report/quick_edit/screens/user/lib.php
index 6f6c469..d5f1520 100644
--- a/grade/report/quick_edit/screens/user/lib.php
+++ b/grade/report/quick_edit/screens/user/lib.php
@@ -4,6 +4,8 @@ class quick_edit_user extends quick_edit_screen {
 
     private $categories = array();
 
+    private $structure;
+
     public function init() {
         global $DB;
 
@@ -14,6 +16,8 @@ class quick_edit_user extends quick_edit_screen {
         $filter_items = grade_report_quick_edit::only_items();
 
         $this->grade_items = array_filter(grade_item::fetch_all($params), $filter_items);
+
+        $this->structure = new grade_structure();
     }
 
     public function html() {
@@ -38,20 +42,18 @@ class quick_edit_user extends quick_edit_screen {
             get_string('range', 'grades'),
             get_string('grade', 'grades'),
             get_string('feedback', 'grades'),
-            get_string('override', 'gradereport_quick_edit'),
-            get_string('exclude', 'gradereport_quick_edit')
+            $this->make_toggle_links('override'),
+            $this->make_toggle_links('exclude')
         );
     }
 
     public function format_line($item) {
         global $OUTPUT;
 
-        $grade = grade_grade::fetch(array(
-            'itemid' => $item->id, 'userid' => $this->user->id
-        ));
+        $grade = $this->fetch_grade_or_default($item, $this->user);
 
         return array(
-            $OUTPUT->pix_icon('t/' . $item->itemtype . '_item', $item->itemname),
+            $this->format_icon($item),
             $this->format_link('grade', $item->id, $item->itemname),
             $this->category($item)->get_name(),
             $this->format_range($item),
@@ -62,6 +64,12 @@ class quick_edit_user extends quick_edit_screen {
         );
     }
 
+    private function format_icon($item) {
+        $element = array('type' => 'item', 'object' => $item);
+
+        return $this->structure->get_element_icon($element);
+    }
+
     private function category($item) {
         if (!isset($this->categories[$item->categoryid])) {
             $category = $item->get_parent_category();
-- 
1.7.1


